/*
 * $ Header: it.geosolutions.geofence.gui.client.i18n.ApplicationMessages,v. 0.1 25-gen-2011 11.24.43 created by afabiani <alessio.fabiani at geo-solutions.it> $
 * $ Revision: 0.1 $
 * $ Date: 25-gen-2011 11.24.43 $
 *
 * ====================================================================
 *
 * Copyright (C) 2007 - 2011 GeoSolutions S.A.S.
 * http://www.geo-solutions.it
 *
 * GPLv3 + Classpath exception
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. 
 *
 * ====================================================================
 *
 * This software consists of voluntary contributions made by developers
 * of GeoSolutions.  For more information on GeoSolutions, please see
 * <http://www.geo-solutions.it/>.
 *
 */
package it.geosolutions.geofence.gui.client.i18n;

import com.google.gwt.i18n.client.Messages;

// TODO: Auto-generated Javadoc
/**
 * The Interface ApplicationMessages.
 */
public interface ApplicationMessages extends Messages {

    // ///////////////////////////
    // PLEASE KEEP THIS FILE SORTED ALPHABETICALLY! Thank you.
    // ///////////////////////////

    /**
     * Accordion label.
     * 
     * @return the string
     */
    public String accordionLabel();


    /**
     * Application name.
     * 
     * @return the string
     */
    public String applicationName();


    /**
     * Binding member detail.
     * 
     * @return the string
     */
    public String bindingMemberDetail();

    /**
     * Clean dg watch dialog message.
     * 
     * @return the string
     */
    public String cleanGeofenceDialogMessage();

    /**
     * Clean dg watch dialog title.
     * 
     * @return the string
     */
    public String cleanGeofenceDialogTitle();

    /**
     * Clean dg watch menu tool tip.
     * 
     * @return the string
     */
    public String cleanGeofenceMenuToolTip();

    /**
     * Delete button label.
     * 
     * @return the string
     */
    public String deleteButtonLabel();

    /**
     * Delete content dialog title.
     * 
     * @return the string
     */
    public String deleteContentDialogTitle();

    /**
     * Delete content tool tip.
     * 
     * @return the string
     */
    public String deleteContentToolTip();

    /**
     * Draw aoi button.
     * 
     * @return the string
     */
    public String drawAoiButton();

    /**
     * Draw feature tool tip.
     * 
     * @return the string
     */
    public String drawFeatureToolTip();

    /**
     * Feature label.
     * 
     * @return the string
     */
    public String recordLabel();

    /**
     * Feature plural label.
     * 
     * @return the string
     */
    public String recordPluralLabel();

    /**
     * Feature not found message.
     * 
     * @return the string
     */
    public String recordNotFoundMessage();

    /**
     * Feature service name.
     * 
     * @return the string
     */
    public String remoteServiceName();

    /**
     * Found label.
     * 
     * @return the string
     */
    public String foundLabel();

    /**
     * Login label.
     * 
     * @return the string
     */
    public String loginLabel();

    /**
     * Login widget title.
     * 
     * @return the string
     */
    public String loginWidgetTitle();

    /**
     * Logout dialog message.
     * 
     * @return the string
     */
    public String logoutDialogMessage();

    /**
     * Logout dialog title.
     * 
     * @return the string
     */
    public String logoutDialogTitle();

    /**
     * Logout tooltip.
     * 
     * @return the string
     */
    public String logoutTooltip();

    /**
     * Member info.
     * 
     * @return the string
     */
    public String memberInfo();

    /**
     * Member details.
     * 
     * @return the string
     */
    public String memberDetails();

    /**
     * Member distribution node fetch failure message.
     * 
     * @param memberName
     *            the member name
     * @return the string
     */
    public String ruleFetchFailureMessage();

    /**
     * Member distribution node fetch success message.
     * 
     * @param memberName
     *            the member name
     * @return the string
     */
    public String ruleFetchSuccessMessage();

    /**
     * Member name.
     * 
     * @return the string
     */
    public String memberName();

    /**
     * Member management label.
     * 
     * @return the string
     */
    public String ruleManagementLabel();

    /**
     * Member service name.
     * 
     * @return the string
     */
    public String ruleServiceName();

    /**
     * Member uid.
     * 
     * @return the string
     */
    public String memberUID();

    /**
     * Password label.
     * 
     * @return the string
     */
    public String passwordLabel();

    /**
     * Please wait message.
     * 
     * @return the string
     */
    public String pleaseWaitMessage();

    /**
     * Reset label.
     * 
     * @return the string
     */
    public String resetLabel();

    /**
     * Save tool tip.
     * 
     * @return the string
     */
    public String saveToolTip();

    /**
     * Save pending.
     * 
     * @return the string
     */
    public String savePending();
    
    /**
     * User fetch success message.
     * 
     * @return the string
     */
    public String userFetchSuccessMessage();
    
    /**
     * User management label.
     * 
     * @return the string
     */
    public String userManagementLabel();

    /**
     * Username label.
     * 
     * @return the string
     */
    public String usernameLabel();
    
    /**
     * User service Name.
     * 
     * @return the string
     */
    public String userServiceName();

    /**
     * Wkt abbreviation.
     * 
     * @return the string
     */
    public String wktAbbreviation();

    /**
     * Zoom in tool tip.
     * 
     * @return the string
     */
    public String zoomInToolTip();

    /**
     * Zoom out tool tip.
     * 
     * @return the string
     */
    public String zoomOutToolTip();
    
    /**
     * The Rule Details Edit Dialog ID
     * 
     * @return String
     */
    public String ruleDialogId();
    
    /**
     * The Profile Details Edit Dialog ID
     * 
     * @return String
     */
    public String profileDialogId();
    
    /**
     * The User Details Edit Dialog ID
     * 
     * @return String
     */
    public String userDialogId();

    // ///////////////////////////
    // PLEASE KEEP THIS FILE SORTED ALPHABETICALLY! Thank you.
    // ///////////////////////////

}
